Bug 912686 - Review Request: sfntly - A Library for Using, Editing, and Creating SFNT-based Fonts
Summary: Review Request: sfntly - A Library for Using, Editing, and Creating SFNT-base...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: gil cattaneo
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-02-19 12:22 UTC by Parag Nemade
Modified: 2013-09-23 00:34 UTC (History)
3 users (show)

Fixed In Version: sfntly-0-0.6.r214.fc20
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-09-20 16:27:06 UTC
Type: ---
puntogil: fedora-review+
kevin: fedora-cvs+


Attachments (Terms of Use)

Description Parag Nemade 2013-02-19 12:22:12 UTC
Spec URL: http://paragn.fedorapeople.org/fedora-work/SPECS/sfnttool.spec
SRPM URL: http://paragn.fedorapeople.org/fedora-work/SRPMS/sfnttool-0-0.1.r125.fc18.src.rpm

Description: 
sfntly is a Java library for using, editing, and creating sfnt
container based fonts (e.g. OpenType, TrueType). This library
was initially created by Google's Font Team.

The basic features of sfntly are the reading, editing,
and writing of an sfnt container font.

Fedora Account System Username: pnemade

Comment 1 Parag Nemade 2013-02-19 12:57:39 UTC
This is my first Java package and I really need a help here to fix any packaging issues for sfnttool.

Comment 2 Stanislav Ochotnicky 2013-02-19 13:48:03 UTC
So few issues first:
- buildroot is no longer needed
- Source0 is unversioned so it can change and it's going to be hard to notice. Contacting upstream about properly versioning their releases would be a good idea
- related to above to ensure stable tarball whenever it's recreated it would be better to use SVN directly and export exact revision & make a tarball out of it (with comment explaining the steps)
- java/lib directory contains bundled libraries (icu4j, junit) these need to be removed during %prep and proper BR added

Comment 3 Parag Nemade 2013-02-20 07:15:01 UTC
Updated but unable to patch build.xml or common.xml to use system dependent libraries. 

Spec URL: http://paragn.fedorapeople.org/fedora-work/SPECS/sfnttool.spec
SRPM URL: http://paragn.fedorapeople.org/fedora-work/SRPMS/sfnttool-0-0.1.r151.fc18.src.rpm

I also tried changing from common.xml
    <fileset dir="${lib.dir}" includes="**/*.jar"/>
to
    <fileset dir="/usr/share/java" includes="*.jar"/>

but compilation failed.

Comment 4 Parag Nemade 2013-08-23 09:42:14 UTC
finally I did some trial and run changes and here is working srpm

Spec URL: http://paragn.fedorapeople.org/fedora-work/SPECS/sfnttool.spec
SRPM URL: http://paragn.fedorapeople.org/fedora-work/SRPMS/sfnttool-0-0.1.r214.fc19.src.rpm

Note:- this package works on F19+ only

Comment 5 Parag Nemade 2013-08-23 10:54:14 UTC
koji scratch build for f19 -> http://koji.fedoraproject.org/koji/taskinfo?taskID=5845114

Comment 6 Mat Booth 2013-08-26 11:47:59 UTC
You should include a copy of the licence (the COPYING file) as a %doc in both the main package and the javadoc package.

Comment 8 gil cattaneo 2013-08-29 13:59:48 UTC
hi
here is available a mavenized release 
https://github.com/witwall/sfntly-java/
please, remove jpackage-utils reference from javadoc subpackage
regards

Comment 10 Parag Nemade 2013-08-29 14:14:56 UTC
sorry I don't know much about java, maven.

What I see the code I am using is recent. Svn revision 214 and the above 2 github mirrors looks old.

Comment 11 Parag Nemade 2013-09-05 16:28:40 UTC
Thanks git for brief help on irc. Here is updated package

Spec URL: http://paragn.fedorapeople.org/fedora-work/SPECS/sfnttool.spec
SRPM URL: http://paragn.fedorapeople.org/fedora-work/SRPMS/sfnttool-0-0.3.r214.fc19.src.rpm

Comment 14 Parag Nemade 2013-09-05 17:50:09 UTC
here are renamed, updated package links
Spec URL: http://paragn.fedorapeople.org/fedora-work/SPECS/sfntly.spec
SRPM URL: http://paragn.fedorapeople.org/fedora-work/SRPMS/sfntly-0-0.4.r214.fc19.src.rpm

Comment 16 gil cattaneo 2013-09-06 18:10:40 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Bundled jar/class files should be removed before build
  Note: Jar files in source (see attachment)
  See: http://fedoraproject.org/wiki/Packaging:Java#Pre-
  built_JAR_files_.2F_Other_bundled_software'


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated". 20 files have unknown license.
     Detailed output of licensecheck in
     /home/gil/912686-sfntly/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[-]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[?]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: Pom files have correct Maven mapping
     Note: Some add_maven_depmap calls found. Please check if they are correct
     or update to latest guidelines
[x]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DOES NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use %{_mavenpomdir} instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in sfntly-
     javadoc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[?]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: sfntly-0-0.5.r214.fc21.noarch.rpm
          sfntly-javadoc-0-0.5.r214.fc21.noarch.rpm
          sfntly-0-0.5.r214.fc21.src.rpm
sfntly.noarch: W: spelling-error %description -l en_US sfnt -> sent
sfntly.noarch: W: no-manual-page-for-binary sfntly
sfntly.src: W: spelling-error %description -l en_US sfnt -> sent
sfntly.src: W: invalid-url Source0: sfntly.tar.xz
3 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint sfntly sfntly-javadoc
sfntly.noarch: W: spelling-error %description -l en_US sfnt -> sent
sfntly.noarch: W: no-manual-page-for-binary sfntly
2 packages and 0 specfiles checked; 0 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
sfntly (rpmlib, GLIBC filtered):
    /bin/sh
    beust-jcommander
    icu4j
    icu4j-charset
    java
    jpackage-utils

sfntly-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils



Provides
--------
sfntly:
    mvn(com.google.typography.font.sfntly:sfntly)
    mvn(com.google.typography.font.sfntly:sfnttool)
    sfntly

sfntly-javadoc:
    sfntly-javadoc



Jar and class files in source
-----------------------------
./sfntly/java/lib/junit-4.10.jar
./sfntly/java/lib/icu4j-charset-4_8_1_1.jar
./sfntly/java/lib/icu4j-4_8_1_1.jar
./sfntly/java/lib/jcommander-1.27.jar


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 912686 -m fedora-rawhide-i386
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG

Not approved

- Bundled jar/class files should be removed before build
  Note: Jar files in source (see attachment)
  See: http://fedoraproject.org/wiki/Packaging:Java#Pre-
  built_JAR_files_.2F_Other_bundled_software'

please , you have to be sure you do not have these libraries in the source archive
i apologized for this inconvenience
you must use
find sfntly -name "*.class" -delete
find sfntly -name "*.jar" -delete
instead of 
find sfntly -name ".class" -delete
find sfntly -name ".jar" -delete
regards

Comment 17 gil cattaneo 2013-09-06 18:12:07 UTC
now 
you should use
 find sfntly-0 -name "*.class" -delete
 find sfntly-0 -name "*.jar" -delete

Comment 18 gil cattaneo 2013-09-06 18:20:37 UTC
another question:
why dont run test suite?

e.g

...
%check
pushd java
ant -Dlib.dir=%{_javadir} test
popd

%files
...

i tried on my system

test:
    [mkdir] Created dir: /home/gil/rpmbuild/BUILD/sfntly-0/java/report
    [junit] Running com.google.typography.font.sfntly.CMapEditingTests
    [junit] Tests run: 4, Failures: 0, Errors: 4, Time elapsed: 0.448 sec
    [junit] Test com.google.typography.font.sfntly.CMapEditingTests FAILED
    [junit] Running com.google.typography.font.sfntly.GlyphEditingTests
    [junit] Tests run: 3, Failures: 0, Errors: 3, Time elapsed: 0.298 sec
    [junit] Test com.google.typography.font.sfntly.GlyphEditingTests FAILED
    [junit] Running com.google.typography.font.sfntly.GlyphTests
    [junit] Tests run: 1, Failures: 0, Errors: 1, Time elapsed: 0.284 sec
    [junit] Test com.google.typography.font.sfntly.GlyphTests FAILED
    [junit] Running com.google.typography.font.sfntly.HdmxTests
    [junit] Tests run: 2, Failures: 0, Errors: 2, Time elapsed: 0.307 sec
    [junit] Test com.google.typography.font.sfntly.HdmxTests FAILED
    [junit] Running com.google.typography.font.sfntly.HheaTests
    [junit] Tests run: 2, Failures: 0, Errors: 0, Time elapsed: 0.371 sec
    [junit] Running com.google.typography.font.sfntly.LoadingTests
    [junit] Tests run: 1, Failures: 0, Errors: 1, Time elapsed: 0.295 sec
    [junit] Test com.google.typography.font.sfntly.LoadingTests FAILED
    [junit] Running com.google.typography.font.sfntly.MetricsTests
    [junit] Tests run: 1, Failures: 0, Errors: 1, Time elapsed: 0.298 sec
    [junit] Test com.google.typography.font.sfntly.MetricsTests FAILED
    [junit] Running com.google.typography.font.sfntly.NameEditingTests
    [junit] Tests run: 4, Failures: 0, Errors: 4, Time elapsed: 0.292 sec
    [junit] Test com.google.typography.font.sfntly.NameEditingTests FAILED
    [junit] Running com.google.typography.font.sfntly.NameTests
    [junit] Tests run: 1, Failures: 0, Errors: 1, Time elapsed: 0.3 sec
    [junit] Test com.google.typography.font.sfntly.NameTests FAILED
    [junit] Running com.google.typography.font.sfntly.OS2Tests
    [junit] Tests run: 3, Failures: 0, Errors: 1, Time elapsed: 0.395 sec
    [junit] Test com.google.typography.font.sfntly.OS2Tests FAILED
    [junit] Running com.google.typography.font.sfntly.OTFBasicEditingTests
    [junit] Tests run: 2, Failures: 0, Errors: 2, Time elapsed: 0.302 sec
    [junit] Test com.google.typography.font.sfntly.OTFBasicEditingTests FAILED
    [junit] Running com.google.typography.font.sfntly.data.ByteArrayTests
    [junit] Tests run: 2, Failures: 0, Errors: 0, Time elapsed: 0.37 sec
    [junit] Running com.google.typography.font.sfntly.data.FontDataTests
    [junit] Tests run: 3, Failures: 0, Errors: 0, Time elapsed: 3.938 sec
    [junit] Running com.google.typography.font.sfntly.data.OpenTypeDataTests
    [junit] Tests run: 2, Failures: 0, Errors: 0, Time elapsed: 0.278 sec
    [junit] Running com.google.typography.font.sfntly.issue_tests.Issue27Tests
    [junit] Tests run: 1, Failures: 0, Errors: 1, Time elapsed: 0.287 sec
    [junit] Test com.google.typography.font.sfntly.issue_tests.Issue27Tests FAILED
    [junit] Running com.google.typography.font.sfntly.issue_tests.Issue28Tests
    [junit] Tests run: 1, Failures: 0, Errors: 1, Time elapsed: 0.29 sec
    [junit] Test com.google.typography.font.sfntly.issue_tests.Issue28Tests FAILED
    [junit] Running com.google.typography.font.tools.conversion.eot.BitIOWriterTest
    [junit] Tests run: 3, Failures: 0, Errors: 0, Time elapsed: 0.285 sec
    [junit] Running com.google.typography.font.tools.conversion.eot.CvtEncoderTest
    [junit] Tests run: 1, Failures: 0, Errors: 0, Time elapsed: 0.384 sec
    [junit] Running com.google.typography.font.tools.conversion.eot.EOTWriterTest
    [junit] Tests run: 1, Failures: 0, Errors: 1, Time elapsed: 0.311 sec
    [junit] Test com.google.typography.font.tools.conversion.eot.EOTWriterTest FAILED
    [junit] Running com.google.typography.font.tools.conversion.eot.GlyfEncoderTest
    [junit] Tests run: 20, Failures: 0, Errors: 0, Time elapsed: 0.312 sec
    [junit] Running com.google.typography.font.tools.conversion.eot.HuffmanEncoderTest
    [junit] Tests run: 3, Failures: 0, Errors: 0, Time elapsed: 0.294 sec
    [junit] Running com.google.typography.font.tools.conversion.eot.MagnitudeDependentWriterTest
    [junit] Tests run: 2, Failures: 0, Errors: 0, Time elapsed: 0.29 sec
    [junit] Running com.google.typography.font.tools.subsetter.BasicSubsetTests
    [junit] Tests run: 1, Failures: 0, Errors: 1, Time elapsed: 0.304 sec
    [junit] Test com.google.typography.font.tools.subsetter.BasicSubsetTests FAILED
    [junit] Running com.google.typography.font.tools.subsetter.CMapTableBuilderTest
    [junit] Tests run: 1, Failures: 0, Errors: 0, Time elapsed: 0.448 sec
    [junit] Running com.google.typography.font.tools.subsetter.HintStripTest
    [junit] Tests run: 7, Failures: 0, Errors: 7, Time elapsed: 0.301 sec
    [junit] Test com.google.typography.font.tools.subsetter.HintStripTest FAILED
    [junit] Running com.google.typography.font.tools.subsetter.HorizontalMetricsTableBuilderTest
    [junit] Tests run: 1, Failures: 0, Errors: 0, Time elapsed: 0.396 sec
    [junit] Running com.google.typography.font.tools.subsetter.PostScriptTableBuilderTest
    [junit] Tests run: 1, Failures: 0, Errors: 0, Time elapsed: 0.416 sec
    [junit] Running com.google.typography.font.tools.subsetter.RenumberingSubsetTest
    [junit] Tests run: 9, Failures: 0, Errors: 9, Time elapsed: 0.292 sec
    [junit] Test com.google.typography.font.tools.subsetter.RenumberingSubsetTest FAILED

causes of tests failures is 
java.io.FileNotFoundException: ../data/testdata/OpenSans-Regular.ttf (No such file or directory)

Comment 19 Parag Nemade 2013-09-07 01:49:39 UTC
Thanks gil. I will do required changed before importing in Fedora this package.

New Package SCM Request
=======================
Package Name: sfntly
Short Description: A Library for Using, Editing, and Creating SFNT-based Fonts
Owners: pnemade
Branches: f19 f20
InitialCC: i18n-team

Comment 20 Parag Nemade 2013-09-07 01:52:08 UTC
oops! Can you please set it again? 

Damn! I should not just restore firefox sessions and comment without reloading pages.

Comment 21 gil cattaneo 2013-09-07 08:56:26 UTC
APPROVED

Comment 22 Kevin Fenzi 2013-09-07 17:32:12 UTC
Git done (by process-git-requests).

Comment 23 Fedora Update System 2013-09-10 09:22:18 UTC
sfntly-0-0.6.r214.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/sfntly-0-0.6.r214.fc20

Comment 24 Fedora Update System 2013-09-10 16:24:06 UTC
sfntly-0-0.6.r214.fc20 has been pushed to the Fedora 20 testing repository.

Comment 25 Fedora Update System 2013-09-11 03:48:33 UTC
sfntly-0-0.6.r214.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/sfntly-0-0.6.r214.fc19

Comment 26 Fedora Update System 2013-09-20 16:27:06 UTC
sfntly-0-0.6.r214.fc19 has been pushed to the Fedora 19 stable repository.

Comment 27 Fedora Update System 2013-09-23 00:34:21 UTC
sfntly-0-0.6.r214.fc20 has been pushed to the Fedora 20 stable repository.


Note You need to log in before you can comment on or make changes to this bug.